/*
 *  Linker script
 */

ENTRY(start)
SECTIONS 
{
  
	IRAMStart  = 0x80000000;
	IRAMSize   = 0x00020000;
	
	DDRStart   = 0xc0000000;
	DDRSize	   = 0x08000000;
	
	DRAMStart  = 0x80000000;
	DRAMSize   = 0x00020000;

	NORStart   = 0x60000000;
	NORSize    = 0x04000000;
	
	STACK_START = IRAMStart + IRAMSize;
	STACK_SIZE  = 0x0000800;
	
  . = IRAMStart;
  .text    : 
  {
    *(.text:.start)
    *(.text)
    . = ALIGN(4);
  }
  
  /* Move into .. for placing const and data sections */
  .rodata    :
  {
    *(.rodata*)
    *(.rodata)
    . = ALIGN(4);
  }  
  .data    : 
  {
    *(.data)
    . = ALIGN(4);
  }
        
  .bss    :
  {
    *(.bss) *(COMMON)
    . = ALIGN(4);
  }
}

