/*========================================================================================================================================== 
(c) Copyright OMRON Europe BV 2012
All Right Reserved 
OMRON Development & Engineering 
-------------------------------------------------------------------------------------------------------------------------------------*//** 
@file 

<short description of the file in one sentence>. 

[Optional extended description of the file. More details] 

[@pre <pre-conditions and Environment restrictions>] 
*//*======================================================================================================================================*/ 

/*=== Include files ======================================================================================================================*/ 
#include "assert.h"
#include "util.h"
#include "leds.h"
#include "led_defs.h"

/*=== Constant definitions (File scope) ==================================================================================================*/ 
#define BLINK_LOOP_PERIOD		NS_DELAY_TO_LOOPCNT(1E9)

/*=== Macro definitions (File scope) =====================================================================================================*/ 

/*=== Type definitions (File scope) ======================================================================================================*/ 

/*=== Type definitions for events (File scope) ===========================================================================================*/ 

/*=== Function declarations (File scope) =================================================================================================*/ 

/*=== Macro-function definitions (File scope) ============================================================================================*/ 

/*=== Data definitions (File scope) ======================================================================================================*/ 

/*=== Local Function definitions (File scope) ============================================================================================*/ 

/*=== Global function definitions (Global system or Local sub-system scope) ==============================================================*/ 
void assert(T_ASSERT const error)
{
	unsigned i = 0;
	unsigned itCnt = 0;

	struct ledErrRep {
		unsigned nrBlinks;
		unsigned blinkSpeed;
		unsigned nrOfCycles;
		BOOL block;
	} errRepLookup[ASSERT_MAX] = {
	    { 1, BLINK_LOOP_PERIOD, 50, TRUE }, /* BOOT_IMAGE_NOT_FOUND_ERR */
	    { 2, BLINK_LOOP_PERIOD, 50, TRUE }, /* BOOT_IMAGE_CRC_ERR */
	    { 3, BLINK_LOOP_PERIOD, 50, TRUE }, /* BOOT_SWITCH_ID_ERR */
	    { 4, BLINK_LOOP_PERIOD, 50, TRUE }, /* BOOT_PHY_ID_ERR */
	    { 5, BLINK_LOOP_PERIOD, 50, TRUE }, /* BOOT_OTAGS_ERR */
	    { 6, BLINK_LOOP_PERIOD, 50, TRUE }, /* BOOT_HW_ERR */
	    { 7, BLINK_LOOP_PERIOD, 50, TRUE }, /* BOOT_WATCHDOG_RESET */
	};

	struct ledErrRep* const indErrRep = &errRepLookup[error];

	//Loop forever if wanted
	while ((i < indErrRep->nrOfCycles) || (indErrRep->block != FALSE)) {
		itCnt = 0;
		while (itCnt < indErrRep->nrBlinks) {
			//Enable the ERR-LED
			leds_set(LED_ERR, TRUE);
			UTIL_waitLoopAccurate(indErrRep->blinkSpeed / 2);

			//Disable the ERR-LED
			leds_set(LED_ERR, FALSE);
			UTIL_waitLoopAccurate(indErrRep->blinkSpeed / 2);
			itCnt++;
		}
		//Wait a little while before repeat
		UTIL_waitLoopAccurate(indErrRep->blinkSpeed * 2);

		i++;
	}
}

/* END OF FILE */ 
