/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2012
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file

  Defines the interfaces for the ARM A-tags list generation helper functions required to start the Linux kernel

*//*--------------------------------------------------------------------------------------------------------------------
  Unique identifier generated by svn:
  $Header$

======================================================================================================================*/

#ifndef __ATAGS_H                         /* Only include this file once   */
#define __ATAGS_H                         /* If not defined, define it now */

/*=== Include files ==================================================================================================*/
//A-tag definition in linux @ arch ARM
#include "uapi/asm/setup.h"
#include "types.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/

/*=== Function declarations (Interface functions) ====================================================================*/
struct tag* atags_addStartTag(struct tag* ptag);
struct tag* atags_addMemoryTag(struct tag* ptag, UNS32 start, UNS32 size);
struct tag* atags_addCommandlineTag(struct tag* ptag, char const* const commandline, char const* const * const commandlineAdd);
struct tag* atags_addInitrdTag(struct tag* ptag, UNS32 initrd_start, UNS32 initrd_end);
struct tag* atags_addEndTag(struct tag* ptag);

#endif

