/*
 * TI Booting and Flashing Utilities
 *
 * Header for the debug routines
 *
 * Copyright (C) 2009 Texas Instruments Incorporated - http://www.ti.com/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any
 * kind, whether express or implied; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* --------------------------------------------------------------------------
  AUTHOR      : Daniel Allred
 --------------------------------------------------------------------------- */

#ifndef _DEBUG_H_
#define _DEBUG_H_

#include "tistdtypes.h"

// Prevent C++ name mangling
#ifdef __cplusplus
extern far "c" {
#endif

/***********************************************************
* Global Macro Declarations                                *
***********************************************************/

/***********************************************************
* Global Typedef declarations                              *
***********************************************************/

/***********************************************************
* Global Function Declarations                             *
***********************************************************/
#define DEBUG_LVL 10

Uint32 DEBUG_printString(char const* const s);
Uint32 DEBUG_printHexInt(Uint32 const i);
Uint32 DEBUG_printHexShort(Uint16 const i);
Uint32 DEBUG_printHexChar(Uint8 const i);
Uint32 DEBUG_readString(char* const s);
Uint32 DEBUG_readChar(char* const c);

#if (DEBUG_LVL >= 0)
 #define DEBUG0_printString DEBUG_printString
#endif
#if (DEBUG_LVL >= 1)
 #define DEBUG1_printString   DEBUG_printString
 #define DEBUG1_printHexInt   DEBUG_printHexInt
 #define DEBUG1_printHexShort DEBUG_printHexShort
 #define DEBUG1_printHexChar  DEBUG_printHexChar
 #define DEBUG1_readString    DEBUG_readString
 #define DEBUG1_readChar      DEBUG_readChar
#else
 #define DEBUG1_printString(a)
 #define DEBUG1_printHexInt(a)
 #define DEBUG1_readString(a)
 #define DEBUG1_readChar(a)
#endif


/***********************************************************
* End file                                                 *
***********************************************************/

#ifdef __cplusplus
}
#endif

#endif //_DEBUG_H_

/* --------------------------------------------------------------------------
    HISTORY
		v1.00  -  DJA  -  07-Nov-2007
 	        Initial release 
 ----------------------------------------------------------------------------- */
