/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2012
  All Right Reserved
  OMRON Development & Engineering
  ---------------------------------------------------------------------------------------------------------------------*/
/**
  @file

  Implements the LED sub-system interface

*/
/*--------------------------------------------------------------------------------------------------------------------
  Unique identifier generated by svn:
  $Header$

======================================================================================================================*/

#ifndef __LEDS_H_
#define __LEDS_H_           

/*=== Include files ==================================================================================================*/
#include "tistdtypes.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Type definitions for events ====================================================================================*/
typedef struct {
    char const* const   description;
    Uint32 const        bank;
    Uint32 const        pin;
    Bool const          inverted;
    Bool const          initOn;         /**< Initial value */
} T_LED;

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/

/*=== Function declarations (Interface functions) ====================================================================*/
void leds_init( T_LED const* const  leds,   unsigned const  ledCount);
void leds_set(  unsigned const      ledNo,  Bool const      on);

#endif
