/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2012
  All Right Reserved
  OMRON Development & Engineering
  ---------------------------------------------------------------------------------------------------------------------*/
/**
  @file

  Implements the interface for Linux reboot2 system-call data parsing for the AM18xx-OMN platform.

  [@pre <pre-conditions and Environment restrictions>]
*/
/*--------------------------------------------------------------------------------------------------------------------
  Unique identifier generated by svn:
  $Header$

======================================================================================================================*/

#ifndef __REBOOTCMD_H_
#define __REBOOTCMD_H_           

/*=== Include files ==================================================================================================*/

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions ===============================================================================================*/
typedef struct {
    int     bootImageNo;    /**< The requested boot image to use.  If < 0, the boot image was not specified*/
    char*   cmdlineAdd;     /**< Additional information to pass to the kernel via the cmdline */
} T_REBOOTCMD;

/*=== Type definitions for events ====================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/

/*=== Function declarations (Interface functions) ====================================================================*/
T_REBOOTCMD const* rebootcmd_parse(void* const rebootRAMend);

#endif
