#include "string.h"

void * memset (void * dest,int val, size_t len)
{
  unsigned char *ptr = (unsigned char*)dest;
  while (len-- > 0)
    *ptr++ = val;
  return dest;
}


char* bcopy(const char * src, char * dest, int count)
{
    char *tmp = dest;

    while (count--)
        *tmp++ = *src++;

    return dest;
}

void* memcpy(void* dest, const void* src, size_t count)
{
    unsigned long*          dl = (unsigned long*)       dest;
    unsigned long const*    sl = (unsigned long const*) src;
    char*                   dc;
    char const*             sc;

    // copy by word when aligned
    if ((((unsigned long) dest | (unsigned long) src) & (sizeof(*dl) - 1)) == 0) {
        while (count >= sizeof(*dl)) {
            *dl++ = *sl++;
            count -= sizeof(*dl);
        }
    }
    // copy the remaining bytes
    dc = (char *)       dl;
    sc = (char const *) sl;
    while (count--)
        *dc++ = *sc++;

    return dest;
}

int strncmp(const char *s1, const char *s2, size_t n)
{
  unsigned char c1, c2;

  while (n) {
    c1 = *s1++;
    c2 = *s2++;
    if (c1 != c2)
           return c1 < c2 ? -1 : 1;
    if (!c1)
           break;
    n--;
  }
  return 0;
}

size_t strlen(const char * s)
{
  unsigned i = 0;
  while (*s != '\0')
  {
    s++;
    i++;
  }

  return  i;
}

char* strcpy(char* dest, char const* src)
{
    char* retval = dest;
    while (*src != '\0') {
        *dest = *src;
        dest++;
        src++;
    }
    //Copy the null-char
    *dest = *src;
    return retval;
}

char* strncpy(char *dest, const char *src, size_t n)
{
    size_t i;

    for (i = 0; i < n && src[i] != '\0'; i++)
        dest[i] = src[i];
    for (; i < n; i++)
        dest[i] = '\0';

    return dest;
}

/**
 * Prints a value to the DBGU terminal
 * @param dest
 * @param[in] value   Value to print
 * @param[in] base    Base to use (16 for hex, 10 for decimal)
 * @param[in] digits  Minimum number of digits to print
 * @param n
 */
char* u2a(char *dest, unsigned value, unsigned const base, unsigned digits, size_t n)
{
  char      buffer[sizeof(value) * 8 + 1];
  int       idx = sizeof(buffer) - 1;
  buffer[idx--] = '\0';

  do
  {
    unsigned const digit = value % base;

    if(digit < 0xA)
    {
      buffer[idx--] = (char)('0' + digit);
    }
    else
    {
      buffer[idx--] = (char)('A' + (digit - 0xA));
    }
    value /= base;
    if(digits)
      digits--;
  } while((value || digits) && (idx >= 0));
  return strncpy(dest, buffer + (idx + 1), n);
}
