/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2012
  All Right Reserved
  OMRON Development & Engineering
  ---------------------------------------------------------------------------------------------------------------------*/
/**
  @file

  Implements the interface for the U-Boot image boot functionality

*/
/*--------------------------------------------------------------------------------------------------------------------
  Unique identifier generated by svn:
  $Header$

======================================================================================================================*/

#ifndef __UBOOT_H_
#define __UBOOT_H_           

/*=== Include files ==================================================================================================*/
#include "types.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions ===============================================================================================*/
typedef enum {
    UBOOT_HEADER_NOT_FOUND = 0,         // No U-Boot image at image location
    UBOOT_HEADER_INVALID,               // Header CRC fail
    UBOOT_HEADER_TYPE,                  // An unsupported header type was detected
    UBOOT_DEST_INVALID,                 // The destination is not (or partially not) in RAM
    UBOOT_PAYLOAD_INVALID,              // Payload CRC fail
    UBOOT_BOOT_FAILED,
} T_UBOOT_RESULT;

/*=== Type definitions for events ====================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/

/*=== Function declarations (Interface functions) ====================================================================*/
T_UBOOT_RESULT uboot_bootKernelImage(int const          machineType,
                                     void const* const  image,
                                     unsigned int const parms,
                                     unsigned int const addressRAM,
                                     unsigned int const sizeRAM );


#endif
