/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2011
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file

  Linux device driver for the Micrel KSZ8051 PHY

  It is specifically designed by and for Omron to retrieve the link status (up/down, speed, etc). It is not a full
  switch driver for network access.
  @pre -
*//*--------------------------------------------------------------------------------------------------------------------
      Unique identifier generated by svn:
      $Header$

======================================================================================================================*/
#ifndef __KSZ8051_H_
#define __KSZ8051_H_

/*=== Include files ==================================================================================================*/

/*=== Constant definitions ===========================================================================================*/
#define KSZ8051_ID                                     (0x0022155)
#define KSZ8051_GET_ID(phyId1, phyId2)                 ((phyId1 << 12) | ((phyId2 >> 4) & 0x0FFF))
#define KSZ8051_GET_SILICON_REV(phyId2)                (phyId2 & 0x000F)

#define KSZ8051_BASIC_CONTROL                          (0x00)
#define KSZ8051_BASIC_STATUS                           (0x01)
#define KSZ8051_PHY_ID_1                               (0x02)
#define KSZ8051_PHY_ID_2                               (0x03)
#define KSZ8051_AUTONEG_AVERTISE                       (0x04)
#define KSZ8051_AUTONEG_LINK_PARTNER                   (0x05)
#define KSZ8051_AUTONEG_EXPANSION                      (0x06)
#define KSZ8051_AUTONEG_NEXT_PAGE                      (0x07)
#define KSZ8051_AUTONEG_LINK_PARTNER_NEXT_PAGE         (0x08)
#define KSZ8051_AFE_CONTROL_1                          (0x11)
#define KSZ8051_RXER_COUNTER                           (0x15)
#define KSZ8051_MODESTRAP_OVERRIDE                     (0x16)
#define KSZ8051_MODESTRAP_STATUS                       (0x17)
#define KSZ8051_EXPANDED_CONTROL                       (0x18)
#define KSZ8051_IRQ_STATUS_CONTROL                     (0x1B)
#define   KSZ8051_IRQ_CONTROL_JABBER                     (1 << 15)
#define   KSZ8051_IRQ_CONTROL_RX_ERR                     (1 << 14)
#define   KSZ8051_IRQ_CONTROL_PAGE_RX                    (1 << 13)
#define   KSZ8051_IRQ_CONTROL_PARL_DET_ERR               (1 << 12)
#define   KSZ8051_IRQ_CONTROL_PART_LINK_ACK              (1 << 11)
#define   KSZ8051_IRQ_CONTROL_LINK_DOWN                  (1 << 10)
#define   KSZ8051_IRQ_CONTROL_REMOTE_FAULT               (1 << 9)
#define   KSZ8051_IRQ_CONTROL_LINK_UP                    (1 << 8)
#define   KSZ8051_IRQ_STATUS_JABBER                      (1 << 7)
#define   KSZ8051_IRQ_STATUS_RX_ERR                      (1 << 6)
#define   KSZ8051_IRQ_STATUS_PAGE_RX                     (1 << 5)
#define   KSZ8051_IRQ_STATUS_PARL_DET_ERR                (1 << 4)
#define   KSZ8051_IRQ_STATUS_PART_LINK_ACK               (1 << 3)
#define   KSZ8051_IRQ_STATUS_LINK_DOWN                   (1 << 2)
#define   KSZ8051_IRQ_STATUS_REMOTE_FAULT                (1 << 1)
#define   KSZ8051_IRQ_STATUS_LINK_UP                     (1 << 0)
#define KSZ8051_LINKMD_CONTROL_STATUS                  (0x1D)
#define KSZ8051_PHY_CONTROL_1                          (0x1E)
#define KSZ8051_PHY_CONTROL_2                          (0x1F)

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/

/*=== Function declarations (Interface functions) ====================================================================*/
#endif


